Index: /trunk/include/VBox/HostServices/GuestControlSvc.h
===================================================================
--- /trunk/include/VBox/HostServices/GuestControlSvc.h	(revision 29515)
+++ /trunk/include/VBox/HostServices/GuestControlSvc.h	(revision 29516)
@@ -244,10 +244,4 @@
     HGCMFunctionParameter env;
 
-    HGCMFunctionParameter std_in;
-
-    HGCMFunctionParameter std_out;
-
-    HGCMFunctionParameter std_err;
-
     HGCMFunctionParameter username;
 
Index: /trunk/include/VBox/VBoxGuestLib.h
===================================================================
--- /trunk/include/VBox/VBoxGuestLib.h	(revision 29515)
+++ /trunk/include/VBox/VBoxGuestLib.h	(revision 29516)
@@ -517,7 +517,4 @@
                                                   char     *pszArgs,        uint32_t  cbArgs,   uint32_t *puNumArgs,
                                                   char     *pszEnv,         uint32_t *pcbEnv,   uint32_t *puNumEnvVars,
-                                                  char     *pszStdIn,       uint32_t  cbStdIn,
-                                                  char     *pszStdOut,      uint32_t  cbStdOut,
-                                                  char     *pszStdErr,      uint32_t  cbStdErr,
                                                   char     *pszUser,        uint32_t  cbUser,
                                                   char     *pszPassword,    uint32_t  cbPassword,
Index: /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibGuestCtrl.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibGuestCtrl.cpp	(revision 29515)
+++ /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibGuestCtrl.cpp	(revision 29516)
@@ -174,7 +174,4 @@
                                               char     *pszArgs,        uint32_t  cbArgs,   uint32_t *puNumArgs,
                                               char     *pszEnv,         uint32_t *pcbEnv,   uint32_t *puNumEnvVars,
-                                              char     *pszStdIn,       uint32_t  cbStdIn,
-                                              char     *pszStdOut,      uint32_t  cbStdOut,
-                                              char     *pszStdErr,      uint32_t  cbStdErr,
                                               char     *pszUser,        uint32_t  cbUser,
                                               char     *pszPassword,    uint32_t  cbPassword,
@@ -189,8 +186,4 @@
     AssertPtr(pcbEnv);
     AssertPtr(puNumEnvVars);
-    AssertPtr(pszStdIn);
-    AssertPtr(pszStdOut);
-    AssertPtr(pszStdOut);
-    AssertPtr(pszStdErr);
     AssertPtr(pszUser);
     AssertPtr(pszPassword);
@@ -212,7 +205,4 @@
     VbglHGCMParmUInt32Set(&Msg.cb_env, 0);
     VbglHGCMParmPtrSet(&Msg.env, pszEnv, *pcbEnv);
-    VbglHGCMParmPtrSet(&Msg.std_in, pszStdIn, cbStdIn);
-    VbglHGCMParmPtrSet(&Msg.std_out, pszStdOut, cbStdOut);
-    VbglHGCMParmPtrSet(&Msg.std_err, pszStdErr, cbStdErr);
     VbglHGCMParmPtrSet(&Msg.username, pszUser, cbUser);
     VbglHGCMParmPtrSet(&Msg.password, pszPassword, cbPassword);
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControl.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControl.cpp	(revision 29515)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControl.cpp	(revision 29516)
@@ -136,8 +136,4 @@
                                            /* Environment */
                                            szEnv, &cbEnv, &uNumEnvVars,
-                                           /* Pipes */
-                                           szStdIn,    sizeof(szStdIn),
-                                           szStdOut,   sizeof(szStdOut),
-                                           szStdErr,   sizeof(szStdErr),
                                            /* Credentials */
                                            szUser,     sizeof(szUser),
@@ -153,5 +149,4 @@
         rc = VBoxServiceControlExecProcess(uContextID, szCmd, uFlags, szArgs, uNumArgs,
                                            szEnv, cbEnv, uNumEnvVars,
-                                           szStdIn, szStdOut, szStdErr,
                                            szUser, szPassword, uTimeLimitMS);
     }
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlExec.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlExec.cpp	(revision 29515)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlExec.cpp	(revision 29516)
@@ -643,5 +643,4 @@
                                              const char *pszArgs, uint32_t uNumArgs,
                                              const char *pszEnv, uint32_t cbEnv, uint32_t uNumEnvVars,
-                                             const char *pszStdIn, const char *pszStdOut, const char *pszStdErr,
                                              const char *pszUser, const char *pszPassword, uint32_t uTimeLimitMS)
 {
@@ -700,7 +699,4 @@
         }
 
-        pData->pszStdIn = RTStrDup(pszStdIn);
-        pData->pszStdOut = RTStrDup(pszStdOut);
-        pData->pszStdErr = RTStrDup(pszStdErr);
         pData->pszUser = RTStrDup(pszUser);
         pData->pszPassword = RTStrDup(pszPassword);
@@ -743,7 +739,4 @@
         }
         RTGetOptArgvFree(pData->papszArgs);
-        RTStrFree(pData->pszStdIn);
-        RTStrFree(pData->pszStdOut);
-        RTStrFree(pData->pszStdErr);
         RTStrFree(pData->pszUser);
         RTStrFree(pData->pszPassword);
@@ -909,5 +902,4 @@
                                   const char *pszArgs, uint32_t uNumArgs,
                                   const char *pszEnv, uint32_t cbEnv, uint32_t uNumEnvVars,
-                                  const char *pszStdIn, const char *pszStdOut, const char *pszStdErr,
                                   const char *pszUser, const char *pszPassword, uint32_t uTimeLimitMS)
 {
@@ -922,5 +914,4 @@
                                                       pszArgs, uNumArgs,
                                                       pszEnv, cbEnv, uNumEnvVars,
-                                                      pszStdIn, pszStdOut, pszStdErr,
                                                       pszUser, pszPassword,
                                                       uTimeLimitMS);
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceInternal.h
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceInternal.h	(revision 29515)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceInternal.h	(revision 29516)
@@ -154,7 +154,4 @@
     char    **papszEnv;
     uint32_t  uNumEnvVars;
-    char     *pszStdIn;
-    char     *pszStdOut;
-    char     *pszStdErr;
     char     *pszUser;
     char     *pszPassword;
@@ -302,5 +299,4 @@
                                          const char *pszArgs, uint32_t uNumArgs,
                                          const char *pszEnv, uint32_t cbEnv, uint32_t uNumEnvVars,
-                                         const char *pszStdIn, const char *pszStdOut, const char *pszStdErr,
                                          const char *pszUser, const char *pszPassword, uint32_t uTimeLimitMS);
 extern void VBoxServiceControlExecDestroyThreadData(PVBOXSERVICECTRLTHREADDATAEXEC pThread);
Index: /trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestCtrl.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestCtrl.cpp	(revision 29515)
+++ /trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestCtrl.cpp	(revision 29516)
@@ -98,7 +98,4 @@
     com::SafeArray <BSTR> args;
     com::SafeArray <BSTR> env;
-    Utf8Str Utf8StdIn;
-    Utf8Str Utf8StdOut;
-    Utf8Str Utf8StdErr;
     Utf8Str Utf8UserName;
     Utf8Str Utf8Password;
@@ -297,5 +294,4 @@
             CHECK_ERROR_BREAK(guest, ExecuteProcess(Bstr(Utf8Cmd), uFlags,
                                                     ComSafeArrayAsInParam(args), ComSafeArrayAsInParam(env),
-                                                    Bstr(Utf8StdIn), Bstr(Utf8StdOut), Bstr(Utf8StdErr),
                                                     Bstr(Utf8UserName), Bstr(Utf8Password), u32TimeoutMS,
                                                     &uPID, progress.asOutParam()));
Index: /trunk/src/VBox/Main/GuestImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/GuestImpl.cpp	(revision 29515)
+++ /trunk/src/VBox/Main/GuestImpl.cpp	(revision 29516)
@@ -725,5 +725,4 @@
 STDMETHODIMP Guest::ExecuteProcess(IN_BSTR aCommand, ULONG aFlags,
                                    ComSafeArrayIn(IN_BSTR, aArguments), ComSafeArrayIn(IN_BSTR, aEnvironment),
-                                   IN_BSTR aStdIn, IN_BSTR aStdOut, IN_BSTR aStdErr,
                                    IN_BSTR aUserName, IN_BSTR aPassword,
                                    ULONG aTimeoutMS, ULONG *aPID, IProgress **aProgress)
@@ -790,7 +789,4 @@
         }
 
-        Utf8Str Utf8StdIn(aStdIn);
-        Utf8Str Utf8StdOut(aStdOut);
-        Utf8Str Utf8StdErr(aStdErr);
         Utf8Str Utf8UserName(aUserName);
         Utf8Str Utf8Password(aPassword);
@@ -840,7 +836,4 @@
                     paParms[i++].setUInt32(cbEnv);
                     paParms[i++].setPointer((void*)pvEnv, cbEnv);
-                    paParms[i++].setPointer((void*)Utf8StdIn.raw(), (uint32_t)strlen(Utf8StdIn.raw()) + 1);
-                    paParms[i++].setPointer((void*)Utf8StdOut.raw(), (uint32_t)strlen(Utf8StdOut.raw()) + 1);
-                    paParms[i++].setPointer((void*)Utf8StdErr.raw(), (uint32_t)strlen(Utf8StdErr.raw()) + 1);
                     paParms[i++].setPointer((void*)Utf8UserName.raw(), (uint32_t)strlen(Utf8UserName.raw()) + 1);
                     paParms[i++].setPointer((void*)Utf8Password.raw(), (uint32_t)strlen(Utf8Password.raw()) + 1);
Index: /trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 29515)
+++ /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 29516)
@@ -8497,5 +8497,5 @@
   <interface
      name="IGuest" extends="$unknown"
-     uuid="909a8633-6e99-4d05-a305-dfe29ca1bc1c"
+     uuid="25efde01-dd0b-43b0-9ceb-e4e6307107ac"
      wsmap="managed"
      >
@@ -8673,22 +8673,4 @@
           executed, in form of "NAME=VALUE"; one pair per entry. To unset a
           variable just set its name ("NAME") without a value.
-        </desc>
-      </param>
-      <param name="stdIn" type="wstring" dir="in">
-        <desc>
-          What to do with the standard input (stdin) of the command being
-          executed. Currently not used and has to be set to an empty value.
-        </desc>
-      </param>
-      <param name="stdOut" type="wstring" dir="in">
-        <desc>
-          What to do with the standard output (stdout) of the command being
-          executed. Currently not used and has to be set to an empty value.
-        </desc>
-      </param>
-      <param name="stdErr" type="wstring" dir="in">
-        <desc>
-          What to do with the standard error (stderr) of the command being
-          executed. Currently not used and has to be set to an empty value.
         </desc>
       </param>
Index: /trunk/src/VBox/Main/include/GuestImpl.h
===================================================================
--- /trunk/src/VBox/Main/include/GuestImpl.h	(revision 29515)
+++ /trunk/src/VBox/Main/include/GuestImpl.h	(revision 29516)
@@ -90,5 +90,4 @@
     STDMETHOD(ExecuteProcess)(IN_BSTR aCommand, ULONG aFlags,
                               ComSafeArrayIn(IN_BSTR, aArguments), ComSafeArrayIn(IN_BSTR, aEnvironment),
-                              IN_BSTR aStdIn, IN_BSTR aStdOut, IN_BSTR aStdErr,
                               IN_BSTR aUserName, IN_BSTR aPassword,
                               ULONG aTimeoutMS, ULONG *aPID, IProgress **aProgress);