Index: trunk/src/VBox/Additions/common/VBoxService/VBoxService.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxService.cpp	(revision 29583)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxService.cpp	(revision 29594)
@@ -110,29 +110,31 @@
 static int VBoxServiceUsage(void)
 {
-    RTPrintf("usage: %s [-f|--foreground] [-v|--verbose] [-i|--interval <seconds>]\n"
-             "           [--disable-<service>] [--enable-<service>] [-h|-?|--help]\n", g_pszProgName);
-#ifdef RT_OS_WINDOWS
-    RTPrintf("           [-r|--register] [-u|--unregister]\n");
-#endif
-    for (unsigned j = 0; j < RT_ELEMENTS(g_aServices); j++)
-        RTPrintf("           %s\n", g_aServices[j].pDesc->pszUsage);
+    RTPrintf("Usage:\n"
+             " %-12s [-f|--foreground] [-v|--verbose] [-i|--interval <seconds>]\n"
+             "              [--disable-<service>] [--enable-<service>] [-h|-?|--help]\n", g_pszProgName);
+#ifdef RT_OS_WINDOWS
+    RTPrintf("              [-r|--register] [-u|--unregister]\n");
+#endif
+    for (unsigned j = 0; j < RT_ELEMENTS(g_aServices); j++)
+        if (g_aServices[j].pDesc->pszUsage)
+            RTPrintf("%s\n", g_aServices[j].pDesc->pszUsage);
     RTPrintf("\n"
              "Options:\n"
-             "    -i | --interval          The default interval.\n"
-             "    -f | --foreground        Don't daemonzie the program. For debugging.\n"
-             "    -v | --verbose           Increment the verbosity level. For debugging.\n"
-             "    -h | -? | --help         Show this message and exit with status 1.\n"
+             "    -i | --interval         The default interval.\n"
+             "    -f | --foreground       Don't daemonzie the program. For debugging.\n"
+             "    -v | --verbose          Increment the verbosity level. For debugging.\n"
+             "    -h | -? | --help        Show this message and exit with status 1.\n"
              );
 #ifdef RT_OS_WINDOWS
-    RTPrintf("    -r | --register          Installs the service.\n"
-             "    -u | --unregister        Uninstall service.\n");
+    RTPrintf("    -r | --register         Installs the service.\n"
+             "    -u | --unregister       Uninstall service.\n");
 #endif
 
     RTPrintf("\n"
-             "Service specific options:\n");
-    for (unsigned j = 0; j < RT_ELEMENTS(g_aServices); j++)
-    {
-        RTPrintf("    --enable-%-10s Enables the %s service. (default)\n", g_aServices[j].pDesc->pszName, g_aServices[j].pDesc->pszName);
-        RTPrintf("    --disable-%-9s Disables the %s service.\n", g_aServices[j].pDesc->pszName, g_aServices[j].pDesc->pszName);
+             "Service-specific options:\n");
+    for (unsigned j = 0; j < RT_ELEMENTS(g_aServices); j++)
+    {
+        RTPrintf("    --enable-%-14s Enables the %s service. (default)\n", g_aServices[j].pDesc->pszName, g_aServices[j].pDesc->pszName);
+        RTPrintf("    --disable-%-13s Disables the %s service.\n", g_aServices[j].pDesc->pszName, g_aServices[j].pDesc->pszName);
         if (g_aServices[j].pDesc->pszOptions)
             RTPrintf("%s", g_aServices[j].pDesc->pszOptions);
@@ -377,5 +379,5 @@
 {
     int rc = VINF_SUCCESS;
-    int iMain = VBoxServiceGetStartedServices();
+    unsigned iMain = VBoxServiceGetStartedServices();
 
     for (unsigned j = 0; j < RT_ELEMENTS(g_aServices); j++)
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControl.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControl.cpp	(revision 29583)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControl.cpp	(revision 29594)
@@ -386,9 +386,9 @@
     "Host-driven Guest Control",
     /* pszUsage. */
-   "[--control-interval <ms>]"
+   "              [--control-interval <ms>]"
     ,
     /* pszOptions. */
-    "    --control-interval  Specifies the interval at which to check for\n"
-    "                        new control commands. The default is 1000 ms.\n"
+    "    --control-interval      Specifies the interval at which to check for\n"
+    "                            new control commands. The default is 1000 ms.\n"
     ,
     /* methods */
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceTimeSync.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceTimeSync.cpp	(revision 29583)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceTimeSync.cpp	(revision 29594)
@@ -624,28 +624,25 @@
     "Time synchronization",
     /* pszUsage. */
-    "[--timesync-interval <ms>] [--timesync-min-adjust <ms>] "
-    "[--timesync-latency-factor <x>] [--timesync-max-latency <ms>]"
-    "[--timesync-set-threshold <ms>] [--timesync-set-start]"
+    "              [--timesync-interval <ms>] [--timesync-min-adjust <ms>]\n"
+    "              [--timesync-latency-factor <x>] [--timesync-max-latency <ms>]\n"
+    "              [--timesync-set-threshold <ms>] [--timesync-set-start]"
     ,
     /* pszOptions. */
-    "    --timesync-interval Specifies the interval at which to synchronize the\n"
-    "                        time with the host. The default is 10000 ms.\n"
-    "    --timesync-min-adjust\n"
-    "                        The minimum absolute drift value measured in\n"
-    "                        milliseconds to make adjustments for.\n"
-    "                        The default is 1000 ms on OS/2 and 100 ms elsewhere.\n"
+    "    --timesync-interval     Specifies the interval at which to synchronize the\n"
+    "                            time with the host. The default is 10000 ms.\n"
+    "    --timesync-min-adjust   The minimum absolute drift value measured in\n"
+    "                            milliseconds to make adjustments for.\n"
+    "                            The default is 1000 ms on OS/2 and 100 ms elsewhere.\n"
     "    --timesync-latency-factor\n"
-    "                        The factor to multiply the time query latency with to\n"
-    "                        calculate the dynamic minimum adjust time.\n"
-    "                        The default is 8 times.\n"
-    "    --timesync-max-latency\n"
-    "                        The max host timer query latency to accept.\n"
-    "                        The default is 250 ms.\n"
+    "                            The factor to multiply the time query latency with\n"
+    "                            to calculate the dynamic minimum adjust time.\n"
+    "                            The default is 8 times.\n"
+    "    --timesync-max-latency  The max host timer query latency to accept.\n"
+    "                            The default is 250 ms.\n"
     "    --timesync-set-threshold\n"
-    "                        The absolute drift threshold, given as milliseconds,\n"
-    "                        where to start setting the time instead of trying to\n"
-    "                        adjust it. The default is 20 min.\n"
-    "    --timesync-set-start\n"
-    "                        Set the time when starting the time sync service.\n"
+    "                            The absolute drift threshold, given as milliseconds,\n"
+    "                            where to start setting the time instead of trying to\n"
+    "                            adjust it. The default is 20 min.\n"
+    "    --timesync-set-start    Set the time when starting the time sync service.\n"
     ,
     /* methods */
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp	(revision 29583)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp	(revision 29594)
@@ -621,9 +621,9 @@
     "Virtual Machine Information",
     /* pszUsage. */
-    "[--vminfo-interval <ms>]"
+    "              [--vminfo-interval <ms>]"
     ,
     /* pszOptions. */
-    "    --vminfo-interval   Specifies the interval at which to retrieve the\n"
-    "                        VM information. The default is 10000 ms.\n"
+    "    --vminfo-interval       Specifies the interval at which to retrieve the\n"
+    "                            VM information. The default is 10000 ms.\n"
     ,
     /* methods */